#ifndef LSGEN
#define LSGEN

#define KEYWORD_AXIOM		"Axiom:"
#define KEYWORD_ANGLE		"Angle:"
#define KEYWORD_GENERATIONS	"Generations:"
#define KEYWORD_FORWARDS	"Forwards:"
#define KEYWORD_RULES		"Rules:"
#define KEYWORD_PRODUCTS	"->"

#define	symbol_a	"A"
#define	value_a		1

#define	symbol_b	"B"
#define	value_b		2

#define	symbol_c	"C"
#define	value_c		3

#define	symbol_d	"D"
#define	value_d		4

#define	symbol_e	"E"
#define	value_e		5

#define	symbol_f	"F"
#define	value_f		6

#define	symbol_g	"G"
#define	value_g		7

#define	symbol_h	"H"
#define	value_h		8



#define	meta_symbol_push	"["
#define	meta_value_push		100

#define	meta_symbol_pop		"]"
#define	meta_value_pop		101

#define	meta_symbol_xp		"/+"
#define	meta_value_xp		102

#define	meta_symbol_xn		"/-"
#define	meta_value_xn		103

#define	meta_symbol_yp		"\\+"
#define	meta_value_yp		104

#define	meta_symbol_yn		"\\-"
#define	meta_value_yn		105

#define	meta_symbol_zp		"|+"
#define	meta_value_zp		106

#define	meta_symbol_zn		"|-"
#define	meta_value_zn		107

#include <list>
#include <vector>
#include <map>

#include <assert.h>

//typedef for common constructs
typedef	std::list<int>			actionType;
typedef	std::vector<int>		forwardsType;
typedef	std::map<int, actionType>	rulesType;
#endif

