#include "lsgenerator.hpp"

actionType
Lsgenerator::generate()
{
	//all containers are supposed to be list< T>,
	//thus no iterators are invalidated ever

	actionType result;

	//inicialize
	result.push_back(axiom_);

	//in every generation
	for(int i = 0; i < gens_; ++i) {
		actionType nres(result);

		//rewrite all posible
		for(actionType::iterator it = result.begin(); it != result.end(); ) {
			rulesType::iterator rule;

			//production rule matches
			if((rule = rules_.find(*it)) != rules_.end()) {

				//result of production rule
				actionType prod = rule->second;

				it = result.erase(it); //pointing to element that followed
				result.insert(it, prod.begin(), prod.end()); //inserts before it

			} else {
				++it;
			}
		}
	}
		
	return result;
}
